Index: sasmodels/models/capped_cylinder.c
===================================================================
--- sasmodels/models/capped_cylinder.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/capped_cylinder.c	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -84,4 +84,33 @@
 }
 
+static double
+radius_from_volume(double radius, double radius_cap, double length)
+{
+    const double vol_cappedcyl = form_volume(radius,radius_cap,length);
+    return cbrt(0.75*vol_cappedcyl/M_PI);
+}
+
+static double
+radius_from_totallength(double radius, double radius_cap, double length)
+{
+    const double hc = radius_cap - sqrt(radius_cap*radius_cap - radius*radius);
+    return 0.5*length + hc;
+}
+
+static double
+effective_radius(int mode, double radius, double radius_cap, double length)
+{
+    switch (mode) {
+    case 1: // equivalent sphere
+        return radius_from_volume(radius, radius_cap, length);
+    case 2: // radius
+        return radius;
+    case 3: // half length
+        return 0.5*length;
+    case 4: // half total length
+        return radius_from_totallength(radius, radius_cap,length);
+    }
+}
+
 static void
 Fq(double q,double *F1, double *F2, double sld, double solvent_sld,
Index: sasmodels/models/capped_cylinder.py
===================================================================
--- sasmodels/models/capped_cylinder.py	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/capped_cylinder.py	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -137,4 +137,7 @@
 source = ["lib/polevl.c", "lib/sas_J1.c", "lib/gauss76.c", "capped_cylinder.c"]
 have_Fq = True
+effective_radius_type = [
+    "equivalent sphere", "radius", "half length", "half total length",
+    ]
 
 def random():
Index: sasmodels/models/core_multi_shell.c
===================================================================
--- sasmodels/models/core_multi_shell.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/core_multi_shell.c	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -9,5 +9,5 @@
 
 static double
-form_volume(double core_radius, double fp_n, double thickness[])
+outer_radius(double core_radius, double fp_n, double thickness[])
 {
   double r = core_radius;
@@ -16,5 +16,22 @@
     r += thickness[i];
   }
-  return M_4PI_3 * cube(r);
+  return r;
+}
+
+static double
+form_volume(double core_radius, double fp_n, double thickness[])
+{
+  return M_4PI_3 * cube(outer_radius(core_radius, fp_n, thickness));
+}
+
+static double
+effective_radius(int mode, double core_radius, double fp_n, double thickness[])
+{
+  switch (mode) {
+  case 1: // outer radius
+    return outer_radius(core_radius, fp_n, thickness);
+  case 2: // core radius
+    return core_radius;
+  }
 }
 
Index: sasmodels/models/core_multi_shell.py
===================================================================
--- sasmodels/models/core_multi_shell.py	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/core_multi_shell.py	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -100,4 +100,5 @@
 source = ["lib/sas_3j1x_x.c", "core_multi_shell.c"]
 have_Fq = True
+effective_radius_type = ["outer radius", "core radius"]
 
 def random():
@@ -144,9 +145,4 @@
     return np.asarray(z), np.asarray(rho)
 
-def ER(radius, n, thickness):
-    """Effective radius"""
-    n = int(n[0]+0.5)  # n is a control parameter and is not polydisperse
-    return np.sum(thickness[:n], axis=0) + radius
-
 demo = dict(sld_core=6.4,
             radius=60,
Index: sasmodels/models/core_shell_bicelle.c
===================================================================
--- sasmodels/models/core_shell_bicelle.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/core_shell_bicelle.c	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -34,4 +34,34 @@
 
     return t;
+}
+
+static double
+radius_from_volume(double radius, double thick_rim, double thick_face, double length)
+{
+    const double volume_bicelle = form_volume(radius,thick_rim,thick_face,length);
+    return cbrt(0.75*volume_bicelle/M_PI);
+}
+
+static double
+radius_from_diagonal(double radius, double thick_rim, double thick_face, double length)
+{
+    const double radius_tot = radius + thick_rim;
+    const double length_tot = length + 2.0*thick_face;
+    return sqrt(radius_tot*radius_tot + 0.25*length_tot*length_tot);
+}
+
+static double
+effective_radius(int mode, double radius, double thick_rim, double thick_face, double length)
+{
+    switch (mode) {
+    case 1: // equivalent sphere
+        return radius_from_volume(radius, thick_rim, thick_face, length);
+    case 2: // outer rim radius
+        return radius + thick_rim;
+    case 3: // half outer thickness
+        return 0.5*length + thick_face;
+    case 4: // half diagonal
+        return radius_from_diagonal(radius,thick_rim,thick_face,length);
+    }
 }
 
Index: sasmodels/models/core_shell_bicelle.py
===================================================================
--- sasmodels/models/core_shell_bicelle.py	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/core_shell_bicelle.py	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -155,4 +155,8 @@
           "core_shell_bicelle.c"]
 have_Fq = True
+effective_radius_type = [
+    "equivalent sphere", "outer rim radius",
+    "half outer thickness", "half diagonal",
+    ]
 
 def random():
Index: sasmodels/models/core_shell_bicelle_elliptical.c
===================================================================
--- sasmodels/models/core_shell_bicelle_elliptical.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/core_shell_bicelle_elliptical.c	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -8,4 +8,39 @@
 {
     return M_PI*(r_minor+thick_rim)*(r_minor*x_core+thick_rim)*(length+2.0*thick_face);
+}
+
+static double
+radius_from_volume(double r_minor, double x_core, double thick_rim, double thick_face, double length)
+{
+    const double volume_bicelle = form_volume(r_minor, x_core, thick_rim,thick_face,length);
+    return cbrt(0.75*volume_bicelle/M_PI);
+}
+
+static double
+radius_from_diagonal(double r_minor, double x_core, double thick_rim, double thick_face, double length)
+{
+    const double radius_max = (x_core < 1.0 ? r_minor : x_core*r_minor);
+    const double radius_max_tot = radius_max + thick_rim;
+    const double length_tot = length + 2.0*thick_face;
+    return sqrt(radius_max_tot*radius_max_tot + 0.25*length_tot*length_tot);
+}
+
+static double
+effective_radius(int mode, double r_minor, double x_core, double thick_rim, double thick_face, double length)
+{
+    switch (mode) {
+    case 1: // equivalent sphere
+        return radius_from_volume(r_minor, x_core, thick_rim, thick_face, length);
+    case 2: // outer rim average radius
+        return 0.5*r_minor*(1.0 + x_core) + thick_rim;
+    case 3: // outer rim min radius
+        return (x_core < 1.0 ? x_core*r_minor+thick_rim : r_minor+thick_rim);
+    case 4: // outer max radius
+        return (x_core > 1.0 ? x_core*r_minor+thick_rim : r_minor+thick_rim);
+    case 5: // half outer thickness
+        return 0.5*length + thick_face;
+    case 6: // half diagonal
+        return radius_from_diagonal(r_minor,x_core,thick_rim,thick_face,length);
+    }
 }
 
Index: sasmodels/models/core_shell_bicelle_elliptical.py
===================================================================
--- sasmodels/models/core_shell_bicelle_elliptical.py	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/core_shell_bicelle_elliptical.py	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -147,4 +147,8 @@
           "core_shell_bicelle_elliptical.c"]
 have_Fq = True
+effective_radius_type = [
+    "equivalent sphere", "outer rim average radius", "outer rim min radius",
+    "outer max radius", "half outer thickness", "half diagonal",
+    ]
 
 def random():
Index: sasmodels/models/core_shell_bicelle_elliptical_belt_rough.c
===================================================================
--- sasmodels/models/core_shell_bicelle_elliptical_belt_rough.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/core_shell_bicelle_elliptical_belt_rough.c	(revision d299327021d8f52877a96e17d973ae9f7ff21c73)
@@ -9,4 +9,40 @@
     return M_PI*(  (r_minor + thick_rim)*(r_minor*x_core + thick_rim)* length +
                  square(r_minor)*x_core*2.0*thick_face  );
+}
+
+static double
+radius_from_volume(double r_minor, double x_core, double thick_rim, double thick_face, double length)
+{
+    const double volume_bicelle = form_volume(r_minor, x_core, thick_rim,thick_face,length);
+    return cbrt(0.75*volume_bicelle/M_PI);
+}
+
+static double
+radius_from_diagonal(double r_minor, double x_core, double thick_rim, double thick_face, double length)
+{
+    const double radius_max = (x_core < 1.0 ? r_minor : x_core*r_minor);
+    const double radius_max_tot = radius_max + thick_rim;
+    const double length_tot = length + 2.0*thick_face;
+    return sqrt(radius_max_tot*radius_max_tot + 0.25*length_tot*length_tot);
+}
+
+static double
+effective_radius(int mode, double r_minor, double x_core, double thick_rim, double thick_face, double length)
+{
+    switch (mode) {
+    case 1: // equivalent sphere
+        return radius_from_volume(r_minor, x_core, thick_rim, thick_face, length);
+    case 2: // outer rim average radius
+        return 0.5*r_minor*(1.0 + x_core) + thick_rim;
+    case 3: // outer rim min radius
+        return (x_core < 1.0 ? x_core*r_minor+thick_rim : r_minor+thick_rim);
+    case 4: // outer max radius
+        return (x_core > 1.0 ? x_core*r_minor+thick_rim : r_minor+thick_rim);
+    case 5: // half outer thickness
+        return 0.5*length + thick_face;
+    case 6: // half diagonal (this ignores the missing "corners", so may give unexpected answer if thick_face
+            //  or thick_rim is extremely large)
+        return radius_from_diagonal(r_minor,x_core,thick_rim,thick_face,length);
+    }
 }
 
Index: sasmodels/models/core_shell_bicelle_elliptical_belt_rough.py
===================================================================
--- sasmodels/models/core_shell_bicelle_elliptical_belt_rough.py	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/core_shell_bicelle_elliptical_belt_rough.py	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -160,4 +160,8 @@
           "core_shell_bicelle_elliptical_belt_rough.c"]
 have_Fq = True
+effective_radius_type = [
+    "equivalent sphere", "outer rim average radius", "outer rim min radius",
+    "outer max radius", "half outer thickness", "half diagonal",
+    ]
 
 demo = dict(scale=1, background=0,
Index: sasmodels/models/core_shell_cylinder.c
===================================================================
--- sasmodels/models/core_shell_cylinder.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/core_shell_cylinder.c	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -11,4 +11,38 @@
 {
     return M_PI*square(radius+thickness)*(length+2.0*thickness);
+}
+
+static double
+radius_from_volume(double radius, double thickness, double length)
+{
+    const double volume_outer_cyl = form_volume(radius,thickness,length);
+    return cbrt(0.75*volume_outer_cyl/M_PI);
+}
+
+static double
+radius_from_diagonal(double radius, double thickness, double length)
+{
+    const double radius_outer = radius + thickness;
+    const double length_outer = length + 2.0*thickness;
+    return sqrt(radius_outer*radius_outer + 0.25*length_outer*length_outer);
+}
+
+static double
+effective_radius(int mode, double radius, double thickness, double length)
+{
+    switch (mode) {
+    case 1: // equivalent sphere
+        return radius_from_volume(radius, thickness, length);
+    case 2: // outer radius
+        return radius + thickness;
+    case 3: // half outer length
+        return 0.5*length + thickness;
+    case 4: // half min outer length
+        return (radius < 0.5*length ? radius + thickness : 0.5*length + thickness);
+    case 5: // half max outer length
+        return (radius > 0.5*length ? radius + thickness : 0.5*length + thickness);
+    case 6: // half outer diagonal
+        return radius_from_diagonal(radius,thickness,length);
+    }
 }
 
Index: sasmodels/models/core_shell_cylinder.py
===================================================================
--- sasmodels/models/core_shell_cylinder.py	(revision e31b19a46729ff0f8f1a5eb9847f69524a6ed1d3)
+++ sasmodels/models/core_shell_cylinder.py	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -132,13 +132,9 @@
 source = ["lib/polevl.c", "lib/sas_J1.c", "lib/gauss76.c", "core_shell_cylinder.c"]
 have_Fq = True
-
-def ER(radius, thickness, length):
-    """
-    Returns the effective radius used in the S*P calculation
-    """
-    radius = radius + thickness
-    length = length + 2 * thickness
-    ddd = 0.75 * radius * (2 * radius * length + (length + radius) * (length + pi * radius))
-    return 0.5 * (ddd) ** (1. / 3.)
+effective_radius_type = [
+    "equivalent sphere", "outer radius", "half outer length",
+    "half min outer dimension", "half max outer dimension",
+    "half outer diagonal",
+    ]
 
 def random():
Index: sasmodels/models/core_shell_ellipsoid.c
===================================================================
--- sasmodels/models/core_shell_ellipsoid.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/core_shell_ellipsoid.c	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -36,4 +36,51 @@
     double vol = M_4PI_3*equat_shell*equat_shell*polar_shell;
     return vol;
+}
+
+static double
+radius_from_volume(double radius_equat_core, double x_core, double thick_shell, double x_polar_shell)
+{
+    const double volume_ellipsoid = form_volume(radius_equat_core, x_core, thick_shell, x_polar_shell);
+    return cbrt(0.75*volume_ellipsoid/M_PI);
+}
+
+static double
+radius_from_curvature(double radius_equat_core, double x_core, double thick_shell, double x_polar_shell)
+{
+    // Trivial cases
+    if (1.0 == x_core && 1.0 == x_polar_shell) return radius_equat_core + thick_shell;
+    if ((radius_equat_core + thick_shell)*(radius_equat_core*x_core + thick_shell*x_polar_shell) == 0.)  return 0.;
+
+    // see equation (26) in A.Isihara, J.Chem.Phys. 18(1950)1446-1449
+    const double radius_equat_tot = radius_equat_core + thick_shell;
+    const double radius_polar_tot = radius_equat_core*x_core + thick_shell*x_polar_shell;
+    const double ratio = (radius_polar_tot < radius_equat_tot
+                          ? radius_polar_tot / radius_equat_tot
+                          : radius_equat_tot / radius_polar_tot);
+    const double e1 = sqrt(1.0 - ratio*ratio);
+    const double b1 = 1.0 + asin(e1) / (e1 * ratio);
+    const double bL = (1.0 + e1) / (1.0 - e1);
+    const double b2 = 1.0 + 0.5 * ratio * ratio / e1 * log(bL);
+    const double delta = 0.75 * b1 * b2;
+    const double ddd = 2.0 * (delta + 1.0) * radius_polar_tot * radius_equat_tot * radius_equat_tot;
+    return 0.5 * cbrt(ddd);
+}
+
+static double
+effective_radius(int mode, double radius_equat_core, double x_core, double thick_shell, double x_polar_shell)
+{
+    const double radius_equat_tot = radius_equat_core + thick_shell;
+    const double radius_polar_tot = radius_equat_core*x_core + thick_shell*x_polar_shell;
+
+    switch (mode) {
+    case 1: // equivalent sphere
+        return radius_from_volume(radius_equat_core, x_core, thick_shell, x_polar_shell);
+    case 2: // average outer curvature
+        return radius_from_curvature(radius_equat_core, x_core, thick_shell, x_polar_shell);
+    case 3: // min outer radius
+        return (radius_polar_tot < radius_equat_tot ? radius_polar_tot : radius_equat_tot);
+    case 4: // max outer radius
+        return (radius_polar_tot > radius_equat_tot ? radius_polar_tot : radius_equat_tot);
+    }
 }
 
Index: sasmodels/models/core_shell_ellipsoid.py
===================================================================
--- sasmodels/models/core_shell_ellipsoid.py	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/core_shell_ellipsoid.py	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -146,13 +146,8 @@
 source = ["lib/sas_3j1x_x.c", "lib/gauss76.c", "core_shell_ellipsoid.c"]
 have_Fq = True
-
-def ER(radius_equat_core, x_core, thick_shell, x_polar_shell):
-    """
-        Returns the effective radius used in the S*P calculation
-    """
-    from .ellipsoid import ER as ellipsoid_ER
-    polar_outer = radius_equat_core*x_core + thick_shell*x_polar_shell
-    equat_outer = radius_equat_core + thick_shell
-    return ellipsoid_ER(polar_outer, equat_outer)
+effective_radius_type = [
+    "equivalent sphere", "average outer curvature",
+    "min outer radius", "max outer radius",
+    ]
 
 def random():
Index: sasmodels/models/core_shell_parallelepiped.c
===================================================================
--- sasmodels/models/core_shell_parallelepiped.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/core_shell_parallelepiped.c	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -25,4 +25,41 @@
         2.0 * length_a * length_b * thick_rim_c;
 #endif
+}
+
+static double
+radius_from_volume(double length_a, double length_b, double length_c,
+                   double thick_rim_a, double thick_rim_b, double thick_rim_c)
+{
+    const double volume = form_volume(length_a, length_b, length_c, thick_rim_a, thick_rim_b, thick_rim_c);
+    return cbrt(volume/M_4PI_3);
+}
+
+static double
+radius_from_crosssection(double length_a, double length_b, double thick_rim_a, double thick_rim_b)
+{
+    const double area_xsec_paral = length_a*length_b + 2.0*thick_rim_a*length_b + 2.0*thick_rim_b*length_a;
+    return sqrt(area_xsec_paral/M_PI);
+}
+
+static double
+effective_radius(int mode, double length_a, double length_b, double length_c,
+                 double thick_rim_a, double thick_rim_b, double thick_rim_c)
+{
+    switch (mode) {
+    case 1: // equivalent sphere
+        return radius_from_volume(length_a, length_b, length_c, thick_rim_a, thick_rim_b, thick_rim_c);
+    case 2: // half outer length a
+        return 0.5 * length_a + thick_rim_a;
+    case 3: // half outer length b
+        return 0.5 * length_b + thick_rim_b;
+    case 4: // half outer length c
+        return 0.5 * length_c + thick_rim_c;
+    case 5: // equivalent circular cross-section
+        return radius_from_crosssection(length_a, length_b, thick_rim_a, thick_rim_b);
+    case 6: // half outer ab diagonal
+        return 0.5*sqrt(square(length_a+ 2.0*thick_rim_a) + square(length_b+ 2.0*thick_rim_b));
+    case 7: // half outer diagonal
+        return 0.5*sqrt(square(length_a+ 2.0*thick_rim_a) + square(length_b+ 2.0*thick_rim_b) + square(length_c+ 2.0*thick_rim_c));
+    }
 }
 
Index: sasmodels/models/core_shell_parallelepiped.py
===================================================================
--- sasmodels/models/core_shell_parallelepiped.py	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/core_shell_parallelepiped.py	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -98,5 +98,5 @@
 is the scattering length of the solvent.
 
-.. note:: 
+.. note::
 
    the code actually implements two substitutions: $d(cos\alpha)$ is
@@ -227,18 +227,10 @@
 source = ["lib/gauss76.c", "core_shell_parallelepiped.c"]
 have_Fq = True
-
-
-def ER(length_a, length_b, length_c, thick_rim_a, thick_rim_b, thick_rim_c):
-    """
-        Return equivalent radius (ER)
-    """
-    from .parallelepiped import ER as ER_p
-
-    a = length_a + 2*thick_rim_a
-    b = length_b + 2*thick_rim_b
-    c = length_c + 2*thick_rim_c
-    return ER_p(a, b, c)
-
-# VR defaults to 1.0
+effective_radius_type = [
+    "equivalent sphere",
+    "half outer length_a", "half outer length_b", "half outer length_c",
+    "equivalent circular cross-section",
+    "half outer ab diagonal", "half outer diagonal",
+    ]
 
 def random():
Index: sasmodels/models/core_shell_sphere.c
===================================================================
--- sasmodels/models/core_shell_sphere.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/core_shell_sphere.c	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -3,4 +3,15 @@
 {
     return M_4PI_3 * cube(radius + thickness);
+}
+
+static double
+effective_radius(int mode, double radius, double thickness)
+{
+    switch (mode) {
+    case 1: // outer radius
+        return radius + thickness;
+    case 2: // core radius
+        return radius;
+    }
 }
 
Index: sasmodels/models/core_shell_sphere.py
===================================================================
--- sasmodels/models/core_shell_sphere.py	(revision da1c8d14693f7a806280e49df578d46f9aa451d8)
+++ sasmodels/models/core_shell_sphere.py	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -78,15 +78,8 @@
 source = ["lib/sas_3j1x_x.c", "lib/core_shell.c", "core_shell_sphere.c"]
 have_Fq = True
+effective_radius_type = ["outer radius", "core radius"]
 
 demo = dict(scale=1, background=0, radius=60, thickness=10,
             sld_core=1.0, sld_shell=2.0, sld_solvent=0.0)
-
-def ER(radius, thickness):
-    """
-        Equivalent radius
-        @param radius: core radius
-        @param thickness: shell thickness
-    """
-    return radius + thickness
 
 def random():
@@ -103,5 +96,5 @@
 
 tests = [
-    [{'radius': 20.0, 'thickness': 10.0}, 'ER', 30.0],
+#    [{'radius': 20.0, 'thickness': 10.0}, 'ER', 30.0],
 
     # The SasView test result was 0.00169, with a background of 0.001
Index: sasmodels/models/cylinder.c
===================================================================
--- sasmodels/models/cylinder.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/cylinder.c	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -11,4 +11,35 @@
 {
     return sas_2J1x_x(qab*radius) * sas_sinx_x(qc*0.5*length);
+}
+
+static double
+radius_from_volume(double radius, double length)
+{
+    return cbrt(0.75*radius*radius*length);
+}
+
+static double
+radius_from_diagonal(double radius, double length)
+{
+    return sqrt(radius*radius + 0.25*length*length);
+}
+
+static double
+effective_radius(int mode, double radius, double length)
+{
+    switch (mode) {
+    case 1:
+        return radius_from_volume(radius, length);
+    case 2:
+        return radius;
+    case 3:
+        return 0.5*length;
+    case 4:
+        return (radius < 0.5*length ? radius : 0.5*length);
+    case 5:
+        return (radius > 0.5*length ? radius : 0.5*length);
+    case 6:
+        return radius_from_diagonal(radius,length);
+    }
 }
 
Index: sasmodels/models/cylinder.py
===================================================================
--- sasmodels/models/cylinder.py	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/cylinder.py	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -139,11 +139,8 @@
 source = ["lib/polevl.c", "lib/sas_J1.c", "lib/gauss76.c", "cylinder.c"]
 have_Fq = True
-
-def ER(radius, length):
-    """
-        Return equivalent radius (ER)
-    """
-    ddd = 0.75 * radius * (2 * radius * length + (length + radius) * (length + pi * radius))
-    return 0.5 * (ddd) ** (1. / 3.)
+effective_radius_type = [
+    "equivalent sphere", "radius",
+    "half length", "half min dimension", "half max dimension", "half diagonal",
+    ]
 
 def random():
Index: sasmodels/models/ellipsoid.c
===================================================================
--- sasmodels/models/ellipsoid.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/ellipsoid.c	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -4,4 +4,46 @@
     return M_4PI_3*radius_polar*radius_equatorial*radius_equatorial;
 }
+
+static double
+radius_from_volume(double radius_polar, double radius_equatorial)
+{
+    return cbrt(radius_polar*radius_equatorial*radius_equatorial);
+}
+
+static double
+radius_from_curvature(double radius_polar, double radius_equatorial)
+{
+    // Trivial cases
+    if (radius_polar == radius_equatorial) return radius_polar;
+    if (radius_polar * radius_equatorial == 0.)  return 0.;
+
+    // see equation (26) in A.Isihara, J.Chem.Phys. 18(1950)1446-1449
+    const double ratio = (radius_polar < radius_equatorial
+                          ? radius_polar / radius_equatorial
+                          : radius_equatorial / radius_polar);
+    const double e1 = sqrt(1.0 - ratio*ratio);
+    const double b1 = 1.0 + asin(e1) / (e1 * ratio);
+    const double bL = (1.0 + e1) / (1.0 - e1);
+    const double b2 = 1.0 + 0.5 * ratio * ratio / e1 * log(bL);
+    const double delta = 0.75 * b1 * b2;
+    const double ddd = 2.0 * (delta + 1.0) * radius_polar * radius_equatorial * radius_equatorial;
+    return 0.5 * cbrt(ddd);
+}
+
+static double
+effective_radius(int mode, double radius_polar, double radius_equatorial)
+{
+    switch (mode) {
+    case 1: // equivalent sphere
+        return radius_from_volume(radius_polar, radius_equatorial);
+    case 2: // average curvature
+        return radius_from_curvature(radius_polar, radius_equatorial);
+    case 3: // min radius
+        return (radius_polar < radius_equatorial ? radius_polar : radius_equatorial);
+    case 4: // max radius
+        return (radius_polar > radius_equatorial ? radius_polar : radius_equatorial);
+    }
+}
+
 
 static void
Index: sasmodels/models/ellipsoid.py
===================================================================
--- sasmodels/models/ellipsoid.py	(revision 01688448fd87fd51ac83d2d724652266c645773a)
+++ sasmodels/models/ellipsoid.py	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -169,26 +169,7 @@
 source = ["lib/sas_3j1x_x.c", "lib/gauss76.c", "ellipsoid.c"]
 have_Fq = True
-
-def ER(radius_polar, radius_equatorial):
-    # see equation (26) in A.Isihara, J.Chem.Phys. 18(1950)1446-1449
-    ee = np.empty_like(radius_polar)
-    idx = radius_polar > radius_equatorial
-    ee[idx] = (radius_polar[idx] ** 2 - radius_equatorial[idx] ** 2) / radius_polar[idx] ** 2
-    idx = radius_polar < radius_equatorial
-    ee[idx] = (radius_equatorial[idx] ** 2 - radius_polar[idx] ** 2) / radius_equatorial[idx] ** 2
-    valid = (radius_polar * radius_equatorial != 0) & (radius_polar != radius_equatorial)
-    bd = 1.0 - ee[valid]
-    e1 = np.sqrt(ee[valid])
-    b1 = 1.0 + np.arcsin(e1) / (e1 * np.sqrt(bd))
-    bL = (1.0 + e1) / (1.0 - e1)
-    b2 = 1.0 + bd / 2 / e1 * np.log(bL)
-    delta = 0.75 * b1 * b2
-    ddd = 2.0 * (delta + 1.0) * (radius_polar * radius_equatorial**2)[valid]
-
-    r = np.zeros_like(radius_polar)
-    r[valid] = 0.5 * cbrt(ddd)
-    idx = radius_polar == radius_equatorial
-    r[idx] = radius_polar[idx]
-    return r
+effective_radius_type = [
+    "equivalent sphere", "average curvature", "min radius", "max radius",
+    ]
 
 def random():
Index: sasmodels/models/elliptical_cylinder.c
===================================================================
--- sasmodels/models/elliptical_cylinder.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/elliptical_cylinder.c	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -3,4 +3,57 @@
 {
     return M_PI * radius_minor * radius_minor * r_ratio * length;
+}
+
+static double
+radius_from_volume(double radius_minor, double r_ratio, double length)
+{
+    const double volume_ellcyl = form_volume(radius_minor,r_ratio,length);
+    return cbrt(0.75*volume_ellcyl/M_PI);
+}
+
+static double
+radius_from_min_dimension(double radius_minor, double r_ratio, double hlength)
+{
+    const double rad_min = (r_ratio > 1.0 ? radius_minor : r_ratio*radius_minor);
+    return (rad_min < hlength ? rad_min : hlength);
+}
+
+static double
+radius_from_max_dimension(double radius_minor, double r_ratio, double hlength)
+{
+    const double rad_max = (r_ratio < 1.0 ? radius_minor : r_ratio*radius_minor);
+    return (rad_max > hlength ? rad_max : hlength);
+}
+
+static double
+radius_from_diagonal(double radius_minor, double r_ratio, double length)
+{
+    const double radius_max = (r_ratio > 1.0 ? radius_minor*r_ratio : radius_minor);
+    return sqrt(radius_max*radius_max + 0.25*length*length);
+}
+
+static double
+effective_radius(int mode, double radius_minor, double r_ratio, double length)
+{
+    switch (mode) {
+    case 1: // equivalent sphere
+        return radius_from_volume(radius_minor, r_ratio, length);
+    case 2: // average radius
+        return 0.5*radius_minor*(1.0 + r_ratio);
+    case 3: // min radius
+        return (r_ratio > 1.0 ? radius_minor : r_ratio*radius_minor);
+    case 4: // max radius
+        return (r_ratio < 1.0 ? radius_minor : r_ratio*radius_minor);
+    case 5: // equivalent circular cross-section
+        return sqrt(radius_minor*radius_minor*r_ratio);
+    case 6: // half length
+        return 0.5*length;
+    case 7: // half min dimension
+        return radius_from_min_dimension(radius_minor,r_ratio,0.5*length);
+    case 8: // half max dimension
+        return radius_from_max_dimension(radius_minor,r_ratio,0.5*length);
+    case 9: // half diagonal
+        return radius_from_diagonal(radius_minor,r_ratio,length);
+    }
 }
 
Index: sasmodels/models/elliptical_cylinder.py
===================================================================
--- sasmodels/models/elliptical_cylinder.py	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/elliptical_cylinder.py	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
@@ -123,20 +123,13 @@
 source = ["lib/polevl.c", "lib/sas_J1.c", "lib/gauss76.c", "elliptical_cylinder.c"]
 have_Fq = True
+effective_radius_type = [
+    "equivalent sphere", "average radius", "min radius", "max radius",
+    "equivalent circular cross-section",
+    "half length", "half min dimension", "half max dimension", "half diagonal",
+    ]
 
 demo = dict(scale=1, background=0, radius_minor=100, axis_ratio=1.5, length=400.0,
             sld=4.0, sld_solvent=1.0, theta=10.0, phi=20, psi=30,
             theta_pd=10, phi_pd=2, psi_pd=3)
-
-def ER(radius_minor, axis_ratio, length):
-    """
-        Equivalent radius
-        @param radius_minor: Ellipse minor radius
-        @param axis_ratio: Ratio of major radius over minor radius
-        @param length: Length of the cylinder
-    """
-    radius = sqrt(radius_minor * radius_minor * axis_ratio)
-    ddd = 0.75 * radius * (2 * radius * length
-                           + (length + radius) * (length + pi * radius))
-    return 0.5 * (ddd) ** (1. / 3.)
 
 def random():
@@ -162,6 +155,6 @@
 
 tests = [
-    [{'radius_minor': 20.0, 'axis_ratio': 1.5, 'length':400.0}, 'ER', 79.89245454155024],
-    [{'radius_minor': 20.0, 'axis_ratio': 1.2, 'length':300.0}, 'VR', 1],
+#    [{'radius_minor': 20.0, 'axis_ratio': 1.5, 'length':400.0}, 'ER', 79.89245454155024],
+#    [{'radius_minor': 20.0, 'axis_ratio': 1.2, 'length':300.0}, 'VR', 1],
 
     # The SasView test result was 0.00169, with a background of 0.001
Index: sasmodels/models/fractal_core_shell.py
===================================================================
--- sasmodels/models/fractal_core_shell.py	(revision eb3eb38c009cc70439ad74fa78055d6551981520)
+++ sasmodels/models/fractal_core_shell.py	(revision 2cc8aa2a798267dbefb6309f9f93a254fa180b82)
@@ -134,6 +134,6 @@
     return radius + thickness
 
-tests = [[{'radius': 20.0, 'thickness': 10.0}, 'ER', 30.0],
-
+#tests = [[{'radius': 20.0, 'thickness': 10.0}, 'ER', 30.0],
+tests = [
 #         # At some point the SasView 3.x test result was deemed incorrect. The
           #following tests were verified against NIST IGOR macros ver 7.850.
